<template>
  <div>
    <no-ssr>
      <SchniSchnaSchnu />
    </no-ssr>
    <SoundButton
      ref="soundButton"
      :src="music"
      :loop="true"
      :autoplay="true"
      class="btn music-button"
    />
  </div>
</template>

<script>
import { Howl } from 'howler'
import { createNamespacedHelpers } from 'vuex'
import SoundButton from 'vue-howler-button/src/components/SoundButton.vue'

const storeModules = {
  map: createNamespacedHelpers('map')
}

export default {
  components: {
    SoundButton,
    SchniSchnaSchnu: process.browser
      ? () => import('~/components/schni_schna_schnu.vue')
      : null
  },

  computed: {
    music() {
      const baseUrl = this.$router.options.base
      return ['music/schni-schna-schnu.ogg', 'music/schni-schna-schnu.mp3'].map(
        url => baseUrl + url
      )
    }
  },

  mounted() {
    this.setMapFilePath(null)
    this.setMapData(null)

    if (localStorage && localStorage.isSoundEnabled !== 'false') {
      const gongSound = new Howl({
        src: ['sounds/gong.ogg', 'sounds/gong.mp3']
      })
      gongSound.play()
    }
  },

  beforeDestroy() {
    this.$refs.soundButton.howl.stop()
  },

  methods: {
    ...storeModules.map.mapActions(['setMapFilePath', 'setMapData'])
  }
}
</script>
